$(() => {
    $("#approximiere").on("click", () => {
        let genauigkeit: number = Number($("#piIn").val());
        let ausgabe: string = "Bei " + genauigkeit + " Schritten ist Pi<br>";

        ausgabe += "Nach Leibnitz etwa " + leibnitz(genauigkeit) + "<br>";
        ausgabe += "Nach Euler etwa " + euler(genauigkeit) + "<br>";
        ausgabe += "Nach Bailey et al etwa " + bbp(genauigkeit) + "<br>";
        ausgabe += "Nach Monte Carlo etwa " + tropfen(genauigkeit);

        $("#piOut").html(ausgabe);
    });
});

function leibnitz(schritte: number): number {
    let pi: number = 0;
    for (let i: number = 0; i < schritte; i++) {
        if (i % 2 == 0) { // Wenn i eine gerade Zahl ist
            pi += (4 / (i * 2 + 1));
        } else { // Wenn i eine ungerade Zahl ist
            pi -= (4 / (i * 2 + 1));
        }
    }
    return pi;
}

function euler(schritte: number): number {
    let pi: number = 3;
    for (let i: number = 1; i < schritte; i++) {
        if (i % 2 == 1) { // Wenn i eine ungerade Zahl ist
            pi += (4 / ((i * 2) * (i * 2 + 1) * (i * 2 + 2)));
        } else {
            pi -= (4 / ((i * 2) * (i * 2 + 1) * (i * 2 + 2)));
        }
    }
    return pi;
}

function bbp(schritte: number): number {
    let pi: number = 0;
    for (let i: number = 0; i <= schritte; i++) {
        pi += (1 / 16 ** i) * (4 / (8 * i + 1) - 2 / (8 * i + 4) - 1 / (8 * i + 5) - 1 / (8 * i + 6));
    }
    return pi;
}

function tropfen(tropfen: number): number {
    let innerhalb: number = 0;
    for (let i: number = 0; i < tropfen; i++) {
        let x: number = Math.random();
        let y: number = Math.random();
        if (x * x + y * y < 1) {
            innerhalb++;
        }
    }
    return 4 * innerhalb / tropfen;
}